unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IMGParser2000, Mail2000, ComCtrls, ExtCtrls, INIFiles;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    ImgParser20001: TImgParser2000;
    Msg: TMailMessage2000;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel2: TPanel;
    ProgressBar1: TProgressBar;
    Panel1: TPanel;
    StaticText1: TStaticText;
    PageControl2: TPageControl;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    Panel3: TPanel;
    Button1: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Label32: TLabel;
    Memo1: TRichEdit;
    TabSheet7: TTabSheet;
    ListBox5: TListBox;
    TabSheet8: TTabSheet;
    ListBox6: TListBox;
    TabSheet9: TTabSheet;
    TabSheet10: TTabSheet;
    TabSheet11: TTabSheet;
    TabSheet12: TTabSheet;
    ListBox7: TListBox;
    ListBox8: TListBox;
    ListBox9: TListBox;
    ListBox10: TListBox;
    TabSheet13: TTabSheet;
    Bevel1: TBevel;
    Panel4: TPanel;
    Label1: TLabel;
    Button2: TButton;
    SMTP: TSMTP2000;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    e_NameTo: TEdit;
    Label3: TLabel;
    e_EmailTo: TEdit;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    e_NameFrom: TEdit;
    e_EMailFrom: TEdit;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    e_Host: TEdit;
    Label7: TLabel;
    e_User: TEdit;
    Label8: TLabel;
    e_Password: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure ImgParser20001Progress(Sender: TObject; Mode: TProgressMode;
      Max, Position: Integer; Info: String);
    procedure Button9Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SMTPProgress(Sender: TObject; Total, Current: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir :=  ExtractFilepath(Application.ExeName)+'Newsletter';
  if OpenDialog1.Execute then begin
    Memo1.Lines.LoadFromFile(OpenDialog1.Filename);

  end;
end;


procedure TForm1.Button7Click(Sender: TObject);
begin
  ImgParser20001.HTMLText.Text := Memo1.Lines.Text;
  ImgParser20001.Parse;
  Progressbar1.Position := 0;
  StaticText1.Caption := '';
end;

procedure TForm1.ListBox1Click(Sender: TObject);
Var
  i : integer;
begin
  i := TListbox(Sender).ItemIndex;
  Listbox1.ItemIndex := i;
  Listbox2.ItemIndex := i;
  Listbox3.ItemIndex := i;
  Listbox4.ItemIndex := i;
  Listbox5.ItemIndex := i;
  Listbox6.ItemIndex := i;
  Listbox7.ItemIndex := i;
  Listbox8.ItemIndex := i;
  Listbox9.ItemIndex := i;
  Listbox10.ItemIndex := i;            
end;

procedure TForm1.Button8Click(Sender: TObject);
Var
  Position, OldPos : PChar;
  P : PChar;
begin
  if ImgParser20001.CreateCID then
    Memo1.Lines.Text := ImgParser20001.HTMLText.Text;
  Progressbar1.Position := 0;
  StaticText1.Caption := '';

  P := PChar(Memo1.Lines.Text);
  Position := StrPos(P, 'cid:');
  while Position <> nil do begin
    Memo1.SelStart := Position-P;
    Memo1.SelLength := 4;
    Memo1.SelAttributes.Style := [fsBold];
    Memo1.SelAttributes.Color := clRed;
    OldPos := Position+4;
    Position := StrPos(OldPos, 'cid:');
  end;
end;

procedure TForm1.ImgParser20001Progress(Sender: TObject;
  Mode: TProgressMode; Max, Position: Integer; Info: String);
begin
  ProgressBar1.Max := Max;
  ProgressBar1.Position := Position;
  StaticText1.Caption := Info;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  ImgParser20001.abort := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
Var
  INI : TIniFile;
begin
//  if FileExists(ExtractFilePath(Application.Exename)+'Newsletter\Update.htm') then
//    Memo1.Lines.LoadFromFile(ExtractFilePath(Application.Exename)+'Newsletter\Update.htm');

  INI := TIniFile.Create(ExtractFilePath(Application.ExeName)+'IMGParse.ini');
  e_Host.Text := INI.ReadString('POP', 'Host', '');
  e_User.Text := INI.ReadString('POP', 'User', '');
  e_Password.Text := INI.ReadString('POP', 'Password', '');

  e_NameFrom.Text := INI.ReadString('From', 'Name', '');
  e_EMailFrom.Text := INI.ReadString('From', 'EMail', '');

  e_NameTo.Text := INI.ReadString('To', 'Name', '');
  e_EMailTo.Text := INI.ReadString('To', 'EMail', '');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SMTP.Host := e_Host.Text;
  SMTP.UserName := e_User.Text;
  SMTP.Password := e_Password.Text;

  if SMTP.Connect then begin
    if SMTP.Helo then begin
      Msg.Reset;
      Msg.ToList.Clear;
      Msg.CcList.Clear;
      Msg.SetFrom(e_NameFrom.Text, e_EMailFrom.Text);
      Msg.SetReplyTo(e_NameFrom.Text, e_EMailFrom.Text);
      Msg.ToList.Add(e_NameTo.Text, e_EMailTo.Text);
      Msg.Subject := 'IMGParser-Testnewsletter';
      ImgParser20001.HTMLText.Text := Memo1.Text;
      ImgParser20001.AttachFiles;
      ImgParser20001.CreateCID;
      Msg.SetTextHtml(ImgParser20001.HTMLText.Text);


      Msg.SetTextPlain('This E-Mail needs a HTML Mail-Client1');

      if Msg.NeedRebuild then
        Msg.RebuildBody;

      if SMTP.SendMessage then
        ShowMessage('Newsletter sent.')
      else
        ShowMessage('Error: Newsletter not sent.');


    end;
    SMTP.Quit;
  end;
  ProgressBar1.Position := 0;
end;

procedure TForm1.SMTPProgress(Sender: TObject; Total, Current: Integer);
begin
  ProgressBar1.Max := Total;
  ProgressBar1.Position := Current;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
Var
  INI : TIniFile;
begin
  INI := TIniFile.Create(ExtractFilePath(Application.ExeName)+'IMGParse.ini');
  INI.WriteString('POP', 'Host', e_Host.Text);
  INI.WriteString('POP', 'User', e_User.Text);
  INI.WriteString('POP', 'Password', e_Password.Text);

  INI.WriteString('From', 'Name', e_NameFrom.Text);
  INI.WriteString('From', 'EMail', e_EMailFrom.Text);

  INI.WriteString('To', 'Name', e_NameTo.Text);
  INI.WriteString('To', 'EMail', e_EMailTo.Text);
end;

end.
